/* 
 * vim: set sw=8 ts=8 si et :
 * Copyright Guido Socher */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "i2c_m.h"


void help(){
	printf("i2c_linux -- test\n");
	printf("Usage: i2c_linux [-h][-p device] [-c client] [-s num] [-r num] \n");
	printf("Options: -h this help\n");
	printf("         -p set the port, default device is /dev/ttyS0\n");
	printf("         -c set the client\n");
	printf("         -c set the client\n");
	printf("\n");
	printf("commandstring is the string that will be sent to \n");
	printf("the microcontroller.");
	printf("The program prints any results on stdout.\n");
	exit(1);
}

int main(int argc, char **argv)
{
	/* The following things are used for getopt: */
	extern char *optarg;
	extern int optind;
	extern int opterr;
	char *port="/dev/ttyS0";
	int ch;
	//char data[MAX_BUF_LEN+1];
        int i;
        int client = 0;
        int set = -1;
        int reset = -1;

	opterr = 0;
	while ((ch = getopt(argc, argv, "hp:c:r:s:")) != -1) {
		switch (ch) {
			case 'p':
				port = strdup(optarg);
				break;
                        case 'c':
                                client = atoi(optarg) &0xF;
                                break;
                        case 's':
                                set = atoi(optarg) &0x7;
                                break;
                        case 'r':
                                reset = atoi(optarg) &0x7;
                                break;
			case 'h':
				help();
			case '?':
				fprintf(stderr, "ERROR: No such option. -h for help.\n");
				exit(1);
			/*no default action for case */
			}
	}
	if (optind != argc){
		/* exactly one argument must be given */
		help();
	}

	/* open device */
	open_tty(port);

#if 0
        for (i=0; i<0x10; i++)
        {
                if (address_slave(0x10 + i,0))
                        printf("CLIENT %d found\n",i);
                i2cstop();
        }
#endif

        if (!address_slave(0x10 + client,0)) {
                printf("client %d not found\n",client);
                i2cstop();
                exit(1);
        }
        if (set >= 0) {
                printf("SET %d %x\n",set,0x81 | set);
                i2c_tx_byte(0x88 | set);
        }
        if (reset >= 0) {
                printf("RESET %d %x\n",reset,0x80 | reset);
                i2c_tx_byte(0x80 | reset);
        }
        i2cstop();
        if (!address_slave(0x10 + client,1)) {
                printf("client %d not found\n",client);
                i2cstop();
                exit(1);
        }
        printf("STATUS = %x\n",i2c_rx_byte(0));
        i2cstop();





#if 0
	// indoor sensor:
	if (!address_slave(3,0)){
		printf("ERROR: address_slave for write failed\n");
		i2cstop();
		close_tty();
		exit(1);
	}
	i2c_tx_string(argv[optind]);
	i2cstop();
	if (!address_slave(3,1)){
		printf("ERROR: address_slave for read failed\n");
		i2cstop();
		close_tty();
		exit(1);
	}
	i2c_rx_string(data);
	printf("%s\n",data);
	i2cstop();
#endif
	close_tty();
	return(0);
}

